#include <bits/stdc++.h>

using namespace std;

int main()
{
    long N,M,c;
    scanf("%ld%ld",&N,&M);
    long izlaz = 0;
    
    long A[N + 1];
    A[0]= 0;
    long B[M + 1];
    B[0] = 0;
    for(long i = 1;i<=N;i++)
    {
        A[i] = i;
    }
    for(long i = 1;i<=M;i++)
    {
        scanf("%ld", &B[i]);
    }
    for(long i = 0;i<= N - M;i++)
    {
        for (int j=1; j<=M; j++)
        {
            A[i + B[j]] = A[i + j];
        }
    }
    scanf("%ld",&c);
    for(long k = 1;k<=N;k++)
    {
        izlaz = izlaz+pow(c,k)*A[k];
    }
    izlaz = izlaz % 998244353;
    printf("%ld",izlaz);
    
    return 0;
}